#include "crops.h"

Tile::Tile() : /* deze methode is sneller dan wanneer ze in de constructor staan */
size(32),
type(0) {
  if(!m_tile) load_tileset("Gfx/Tile.bmp"); 
  if (!m_tile) cout << "Spritesheet not loaded\n";     
}
Tile::~Tile() {
//  destroy_bitmap(m_tile); 
/* Geen goed idee aangezien de bitmap gedeeld 
  is tussen alle verschillende tiles */
}

void Tile::draw_background(int x, int y) {
     masked_blit(m_tile, buffer, size*tile_x,size*tile_y,x*size,y*size,size,size);
}
int Tile::get_tile() {
  return type;
}
void Tile::load_tileset(const char *tileset) {
  Tile::m_tile = load_bitmap(tileset, NULL);
}
void Tile::set_sprite(int spot) {
// Types:
//   0: Walkable ground
//   1: Soil
   
     switch (spot) {
            case 0:
                 type = 0;
                 tile_x = 0;
                 tile_y = 0;
                 break;
            case 1:
                 type = 1;
                 tile_x = size;
                 tile_y = 0;
                 break;
            case 2:
                 type =  0;
                 tile_x = size*2;
                 tile_y = 0;
                 break;
            case 3:
                 type = 1;
                 tile_x = 0;
                 tile_y = size;
                 break;
            case 4:
                 type = 1;
                 tile_x = size;
                 tile_y = size;
                 break;
            case 5:
                 type = 1;
                 tile_x = size*2;
                 tile_y = size;
                 break;
            case 6:
                 type = 0;
                 tile_x = 0;
                 tile_y = size*2;
                 break;
            case 7:
                 type = 1;
                 tile_x = size;
                 tile_y = size*2;
                 break;
            case 8:
                 type = 0;
                 tile_x = size*2;
                 tile_y = size*2;
                 break;
            case 9:
                 type = 0;
                 tile_x = size*3;
                 tile_y = 0;
                 break;
     }     
}
